'use strict';


// Declare app level module which depends on filters, and services
var application =  angular.module('fierroApp', [
  'ngRoute',
  'fierroApp.filters',
  'fierroApp.services',
  'fierroApp.directives',
  'fierroApp.controllers'
]).
config(['$routeProvider', function($routeProvider) {
    $routeProvider.when('/home', {templateUrl: 'partials/home.html', controller: 'HomeController'});
    $routeProvider.when('/scan', {templateUrl: 'partials/book.html', controller: 'ScanController'});
    $routeProvider.when('/search', {templateUrl: 'partials/search.html', controller: 'SearchController'});
    $routeProvider.when('/book/:id', {templateUrl: 'partials/book.html', controller: 'BookCtrl'});
    $routeProvider.when('/cart', {templateUrl: 'partials/shoppingCart.htm', controller:     storeController});
    $routeProvider.when('/store', {templateUrl: 'partials/store.html', controller: storeController});
    $routeProvider.when('//products/:productSku', {templateUrl: 'partials/product.html', controller: storeController});
    $routeProvider.when('/options', {templateUrl: 'partials/options.html', controller: 'OptionsController'});    
    $routeProvider.otherwise({redirectTo: '/home'});
}]);


// create a data service that provides a store and a shopping cart that
// will be shared by all views (instead of creating fresh ones for each view).

application.factory("DataService", function ($http) {

    // create store
   // var myStore = new store();

    // create shopping cart
    var myCart = new shoppingCart("Paquete", $http);

    myCart.addCheckoutParameters("Google", "xxxxxxx",
        {
        }
    );
       

    // return data object with store and cart
    return {
        cart: myCart
    };
});

  
