'use strict';

var DEBUG = true;

function startLoading(){
    console.log ( 'Start loading' );
    if (DEBUG == false){
        spinnerplugin.show();
        
    }

}

function stopLoading(){
    console.log ( 'Stop loading' );  
    if (DEBUG == false){
        spinnerplugin.hide();
    
    }
}

function showError(txt){
    alert("Error: " + txt);
}

/* Controllers */

angular.module('fierroApp.controllers', [])
  .controller('HomeController', ['$scope', 'Catalog','$location', '$route', function($scope, Catalog, location, route) {
        
        $scope.showForm = true;

        $scope.searchDefault = function(){
             startLoading();               
             var promise = Catalog.queryAll($scope.value);
             promise.then(
                function(result){
                    $scope.books = result;
                    $scope.showForm = false;
                    stopLoading();
                },
                function(error){                    
                    stopLoading();
                    showError("No es posible obtener el resultado.");                
                });
         };
   
  }])
  .controller('ScanController', ['$scope', 'Catalog', function($scope, Catalog) {

       /* Catalog.queryByBarcode('9788432313103').then(function(d) {
            $scope.book = d;
          });
          * */
        cordova.plugins.barcodeScanner.scan(
            function (result) {
                var barcode = result.text;
                Catalog.queryByBarcode(barcode).then(function(d) {
                    $scope.book = d;
                });


		}, 
		function (error) {
			alert("Scanning failed: " + error);
		}
	);
    

  }])
  .controller('SearchController', ['$scope', '$routeParams', '$http', 'Catalog',  function($scope, $routeParams, $http, Catalog) {   
            $scope.showForm = true;

            $scope.search = function(){
                
                 var params = {title: $scope.title, author: $scope.author, editorial: $scope.editorial};
                 startLoading();               
                 Catalog.query(params).then(function(d) {
                    $scope.books = d;                    
                    stopLoading();
                    $scope.showForm = false;
                });
         };  
  }])

    
  .controller('SearchFormCtrlxx', ['$scope', 'Catalog', function($scope, Catalog) {    
            

        
  }])
   .controller('BookCtrl', ['$scope', '$routeParams', 'Catalog', function($scope, $routeParams, Catalog) {    
     
          Catalog.findByPrimaryKey($routeParams.id).then(function(d) {
                $scope.book = d;
          });                
            

        
  }])
   .controller('BookCartCtrl', ['$scope', '$routeParams', 'DataService', function($scope, $routeParams, DataService) {    
     
    // get store and cart from service
    $scope.store = DataService.store;
    $scope.cart = DataService.cart;

        
  }])
  .controller('OptionsController', ['$scope', 'AppConfig', function($scope, AppConfig) {
        console.log("Se instancia OptionsController");
        $scope.formInfo = {};
        $scope.formInfo.baseUrl = AppConfig.getBaseUrl();
        $scope.sucursals = [];
        //VEr si hace falta setear la sucursal acá o alcanza con la carga en el promise
        $scope.formInfo.sucursal = AppConfig.getSucursal();        
        $scope.formInfo.packetName = AppConfig.getPacketName();        
         
        $scope.load = function(){
            var promise = AppConfig.getSucursals();
            promise.then(
                function(result){
                    console.log("Return getSucursals " + $scope.formInfo.sucursal);
                    $scope.sucursals = result;
                    $scope.formInfo.sucursal = $scope.findSucursal($scope.formInfo.sucursal);
                                        
                    stopLoading();
                },
                function(error){                    
                    stopLoading();
                    showError("No es posible cargar las sucursales desde " + AppConfig.getBaseUrl());                
                });
        };
        $scope.load();
        
        $scope.refreshUrl = function(){
            AppConfig.setBaseUrl($scope.formInfo.baseUrl);
            $scope.load();
        };
        $scope.saveData = function(){
            AppConfig.setBaseUrl($scope.formInfo.baseUrl);
            AppConfig.setSucursal($scope.formInfo.sucursal);
            AppConfig.setPacketName($scope.formInfo.packetName);
         };
        $scope.selectAction = function() {
            console.log($scope.formInfo.sucursal);
        };
        $scope.findSucursal = function(sucursal) {
            for (var i = 0; i < $scope.sucursals.length; i++) {
                if ($scope.sucursals[i].code == sucursal) {
                    return $scope.sucursals[i];
                }
            }
        }

  }])
  
    .controller('NavbarController', function NavbarController($scope, $route, $location) {
        $scope.toSearch = function () {
            var dstPath = '/search';
            if ($location.path() === dstPath) {
                $route.reload()  ;
            } else {
                $location.path(dstPath);
            }
        }            
    });

;
// the storeController contains two objects:
// - store: contains the product list
// - cart: the shopping cart object
function storeController($scope, $routeParams, DataService, AppConfig) {

    // get store and cart from service
   // $scope.store = DataService.store;TODO VER
    $scope.cart = DataService.cart;
    $scope.cart.packetName = AppConfig.getPacketName();


//TODO VER
    // use routing to pick the selected product
    if ($routeParams.productSku != null) {
        $scope.product = $scope.store.getProduct($routeParams.productSku);
    }
}
