'use strict';


/* Services */
var module = angular.module('fierroApp.services', []);


module.service('AppConfig', function($http) {
    
    
    this.getBaseUrl = function(){
        var ret = null;
        if (localStorage != null && JSON != null) {
            ret = localStorage.getItem('baseUrl');
            console.log("get baseUrl" + ret);
        }
        return ret;
    }
    
    this.setBaseUrl = function(value){
        if (localStorage != null && JSON != null) {
            localStorage.setItem('baseUrl', value);
        }
    }
    
    this.setSucursal = function(value){
        if (value != null){
            if (localStorage != null && JSON != null) {
                localStorage.setItem('sucursalCode', value.code);
            }
        }
    }
    this.getSucursal = function(){
        var ret = null;
        if (localStorage != null && JSON != null) {
            ret = localStorage.getItem('sucursalCode');
            console.log("get sucursal" + ret);
        }
        return ret;
    }
    this.setPacketName = function(value){
        if (value != null){
            if (localStorage != null && JSON != null) {
                localStorage.setItem('packetName', value);
            }
        }
    }
    this.getPacketName = function(){
        var ret = null;
        if (localStorage != null && JSON != null) {
            ret = localStorage.getItem('packetName');
            console.log("get packet name" + ret);
        }
        return ret;
    }       
    this.getSucursals = function(){
        // $http returns a promise, which has a then function, which also returns a promise
        var promise = $http.get(this.getBaseUrl() + '/catalogo/sucursals.spy')
            .then(function (response) {
          // The then function here is an opportunity to modify the response
          console.log(response);
          // The return value gets picked up by the then in the controller.
          return response.data;
        });
        // Return the promise to the controller
        return promise;
    }
   
});


module.service('Catalog', function($http, AppConfig) {
   
   this.findByPrimaryKey = function(bookId) {
        // $http returns a promise, which has a then function, which also returns a promise        
        var url = AppConfig.getBaseUrl() + '/catalogo/book_mobile.spy?sucursalId=' + AppConfig.getSucursal() + '&id=' + bookId;
        var promise = $http.get(url).then(function (response) {
          // The then function here is an opportunity to modify the response
          console.log(response);
          // The return value gets picked up by the then in the controller.
          return response.data;
        });
        // Return the promise to the controller
        return promise;
  }
   
   this.queryByBarcode = function(barcode) {
        
        // $http returns a promise, which has a then function, which also returns a promise
        //var url = AppConfig.getBaseUrl() + '/catalogo/query_point_book_mobile.spy?sucursalId=' + AppConfig.getSucursal() + '&barcode=' + barcode;
        var url = AppConfig.getBaseUrl() + '/catalogo/search_book_mobile.spy?sucursalId=' + AppConfig.getSucursal() + '&type=barcode&value=' + barcode;
        var promise = $http.get(url).then(function (response) {
          // The then function here is an opportunity to modify the response
          console.log(response);
          // The return value gets picked up by the then in the controller.
          if (response)
                return response.data[0];
        });
        // Return the promise to the controller
        return promise;
  }
  
   this.queryAll = function(value) {
        // $http returns a promise, which has a then function, which also returns a promise
        var url = AppConfig.getBaseUrl() + '/catalogo/search_book_mobile.spy?sucursalId=' + AppConfig.getSucursal() + '&type=all&value=' + value;
        var promise = $http.get(url)
            .then(function (response) {
          // The then function here is an opportunity to modify the response
          console.log(response);
          // The return value gets picked up by the then in the controller.
          return response.data;
        });
        // Return the promise to the controller
        return promise;
  }

   this.query = function(params) {
        // $http returns a promise, which has a then function, which also returns a promise
        var url = AppConfig.getBaseUrl() + '/catalogo/search_book_mobile.spy?sucursalId=' + AppConfig.getSucursal() + '&' + toQueryString(params);
        var promise = $http.get(url)
            .then(function (response) {
          // The then function here is an opportunity to modify the response
          console.log(response);
          // The return value gets picked up by the then in the controller.
          return response.data;
        });
        // Return the promise to the controller
        return promise;
  }

});
function toQueryString(obj) {
    var parts = [];
    for (var i in obj) {
        if (obj.hasOwnProperty(i) && obj[i]!= undefined)  {
            parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
        }
    }
    return parts.join("&");
}
